using System;
using NLua;

namespace SampleApp
{
    public class TestClass
    {
        public void exceptionMethod()
        {
            throw new Exception("exception test");
        }
    }

    class MainClass
    {
        public static void Main(string[] args)
        {
            // script to be executed in lua state
            string script =
                "function run(test)\n" +
                "   err, errMsg = pcall(test.exceptionMethod,test);\n" +
                "   err2, errMsg2 = pcall(test.exceptionMethod,test);\n" +
                "end";

            // instance of TestClass invoked inside the lua script
            TestClass test = new TestClass();

            // create a new lua state
            Lua lua = new Lua();
            // load the script
            var script_func = lua.LoadString(script, "script");
            script_func.Call();

            try
            {
                // execute the script
                (lua["run"] as LuaFunction).Call(test);
            }
            catch (Exception ex)
            {
                // this shouldn't happen
                Console.WriteLine($"{ex.Message}");
            }

            // load and print the exception info from first call
            bool err = (bool)lua["err"];
            var errMsg = (Exception)lua["errMsg"];
            // expected output: "False : NLua.Exceptions.LuaScriptException: A .NET exception occured in user-code"
            Console.WriteLine($"{err} : {errMsg}");

            // load and print the exception info from second call
            bool err2 = (bool)lua["err2"];
            var errMsg2 = (Exception)lua["errMsg2"];
            // expected output: "False : NLua.Exceptions.LuaScriptException: A .NET exception occured in user-code"
            Console.WriteLine($"{err2} : {errMsg2}");
        }
    }
}